# $Id: stats.bro,v 1.1 2004/09/23 06:06:00 vern Exp $

# Track memory/lag statistics.  Differs from profiling.bro in that this
# is lighter-weight (much less info, and less load to generate).

global stats_log = open_log_file("stats");
global last_stats_time = current_time();
global last_stats_CPU_time =
	resource_usage()$user_time + resource_usage()$system_time;

event check_stats()
	{
	local now = current_time();
	local lag = now - network_time();
	local report_delta = now - last_stats_time;

	local res = resource_usage();
	local mem = res$mem;
	local total_CPU_time = res$user_time + res$system_time;
	local CPU_util = (total_CPU_time - last_stats_CPU_time) / report_delta;

	if ( reading_live_traffic() )
		print stats_log,
			fmt("%.06f memory=%d KB, lag=%f sec, utilization=%.0f%%",
				network_time(), mem, lag, CPU_util * 100.0);
	else
		print stats_log, fmt("%.06f memory=%d KB", network_time(), mem);

	last_stats_time = now;
	last_stats_CPU_time = total_CPU_time;
	flush_all();

	schedule 5 sec { check_stats() };
        }

event bro_init()
	{
	schedule 5 sec { check_stats() };
	}
