#!/bin/sh 
# very simple script to compress old files and remove older files
# You will probably want to do something more sophisticated for
#	a production bro installation (e.g.: Integrate this into
#	your backup scripts)
#
# Note: might want to check current disk space and just exit
#	if there is lots of space
#
#set -x


#logdir=/usr/local/bro/logs/

# set this from bro.cfg 
. /usr/local/bro/etc/bro.cfg
echo found BROLOGS in bro.cfg: $BROLOGS
logdir=$BROLOGS/

Days2deletion=60
Days2compression=30

filelist=`find $logdir -type f -mtime +$Days2deletion -print `
#echo list of files to delete: $filelist

for file in $filelist
   do
        echo removing: $file
	rm -f $file
   done

#delete core files that are more than 4 days old
filelist=`find $logdir -name "*core*" -mtime +4 -print `
for file in $filelist
   do
        echo removing: $file
	rm -f $file
   done


filelist=`find $logdir -type f -mtime +$Days2compression -print `
#echo list of files to compress: $filelist

for file in $filelist
   do
        echo compressing: $file
	nice gzip $file
   done

echo Moving compressed files to archive dir: $BRO_LOG_ARCHIVE
mv $logdir/*.gz $BRO_LOG_ARCHIVE
echo Done.
exit
