#!/bin/sh

#install bro into your crontab for checkpointing

# source our cfg or guess at some defaults
if [ -r .bro.cfg ] ; then
    . ./bro.cfg
else
    BRO_REPORT_START_TIME=0000
    BROHOME="/usr/local/bro"
fi

RPT_MIN=`echo ${BRO_REPORT_START_TIME} | cut -f3-`
RPT_HR=`echo ${BRO_REPORT_START_TIME} | cut -f1,2`


install_cron ()
{
    if [ -f /tmp/old.crontab ] ; then                        
        rm  /tmp/old.crontab  
    fi 
    if crontab -l > /tmp/old.crontab ; then 
        if grep bro /tmp/old.crontab > /dev/null; then 
            echo "" 
            echo "Bro already installed in crontab!" 
            echo "Not installing a new crontab" 
            echo "" 
        else 
            echo "0 0 * * * ${BROHOME}/etc/bro.rc --checkpoint" >> /tmp/old.crontab 
            echo "30 0 * * * (cd ${BROHOME}/etc ;. ../etc/bro.cfg; nice -n 19 ./site-report.pl)" >> /tmp/old.crontab 
            echo "0 1 * * * (cd ${BROHOME}/scripts; . ../etc/bro.cfg; ./mail_reports.sh)" >> /tmp/old.crontab 
            crontab /tmp/old.crontab 
            rm /tmp/old.crontab 
            echo "" 
            echo "New crontab installed." 
            echo "" 
        fi 
    else 
        echo "0 0 * * * ${BROHOME}/etc/bro.rc --checkpoint" > /tmp/old.crontab 
        echo "30 0 * * * (cd ${BROHOME}/scripts ; . ../etc/bro.cfg; nice -n 19 ./site-report.pl)" >> /tmp/old.crontab
        echo "0 1 * * * (cd ${BROHOME}/scripts; . ../etc/bro.cfg; ./mail_reports.sh)" >> /tmp/old.crontab 
        crontab  /tmp/old.crontab 
        rm /tmp/old.crontab 
        s=$? 
        if [ $s -ne 0 ] ; then 
            echo "Can NOT install crontab. Please see crontab.example" 
            echo "for an example crontab to install" 
        else 
            echo "" 
            echo "New crontab installed." 
            echo "" 
        fi 
    fi 
}

uninstall_cron()
{
    echo "not implemented (yet)"
}

case $1 in
    install)
        install_cron
        ;;
    uninstall)
        uninstall_cron
        ;;
esac
exit 0
