#!/bin/sh
# 
# Shell script to mail reports, should be called from 
# crontab
# $Id: mail_reports.sh,v 1.4 2004/08/18 19:19:47 jason Exp $
#

# Clean up after ourselves
trap "rm /tmp/bro.report.$$; exit" 1 2 15

# where are we located
base=`dirname $0`

#set the environment
. $base/../etc/bro.cfg

# find the newest report in the report directory
#report=`ls -1t $BRO_REPORT_DIR/local/*.rpt | head -2 | tail -1`
report=`ls -1t $BRO_REPORT_DIR/local/*.rpt | head -1`

# and email it
# if encrypted make sure we have a good (gpg) bin  and keys
if [ $BRO_ENCRYPT_EMAIL = "YES" ] ; then
    if [ -x $BRO_GPG_BIN ] ; then 
        for recpt in $BRO_EMAIL_LOCAL ;  do 
            cat $report | $BRO_GPG_BIN --yes -ea -r $recpt|mail -s "$BRO_HOSTNAME Report" $recpt
        done
    else
        echo "Invalid gpg bin $BRO_GPG_BIN" > /tmp/bro.report.$$
    fi
else # not ENCRYPTED 
    cat $report > /tmp/bro.report.$$ 
fi

# if there was an error or we are sending unencrypted ...
if [ -r /tmp/bro.report.$$ ] ; then 
    for recpt in $BRO_EMAIL_LOCAL ;  do
         cat /tmp/bro.report.$$ | mail -s "$BRO_HOSTNAME Report" $recpt
    done
    rm  /tmp/bro.report.$$
fi
exit 0
